Subject: Re: [Bitcoin-development] Determine input addresses of a transaction

From: Mike Hearn <[email-masked]>
Date: Tue, 25 Oct 2011 12:42:53 +0200

> Interesting suggestion! So if I understand correctly, <greensig> would be
> the signature generated from signing the transaction with the key of a
> green address?

Sure. Or just "a key". It wouldn't have to be an actual key used in
the block chain.

> Sounds good - I guess I never thought in this direction, as I always
> assumed doing anything 'non-standard' with the scripting language would
> create a number of knock-on problems.

It won't break the IsStandard checks, if that's what you mean. You can
put any data you like into a scriptSig. In practice only data is
useful, there's no purpose in having an actual script there (or at
least, I wasn't able to find one yet).

> 1) Get something working reasonable fast to detect current green address
> style transactions. It's fine if it is a little bit of a hack, as long as
> it's safe, since I don't expect it to be merged with mainline anyway at
> this point.

You could easily change the bitcoin code to detect such transactions -
just look for scriptSigs that have 3 items instead of two, where the
3rd item is the right size to be a signature.

> Criticism ranging from 'unnecessary, as
> 0-confirmation transactions are fairly safe today' to 'encourages too much
> centralization and therefore evil'

Heh, if that's a reference to my feedback, I definitely wouldn't
describe such a feature as "evil", that's rather strong :-)